# coding: utf-8

from __future__ import absolute_import

from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from aura_engine_api.rest import util
from aura_engine_api.rest.models.base_model_ import Model
from aura_engine_api.rest.models.play_log import PlayLog  # noqa: F401,E501
from aura_engine_api.rest.models.playlist import Playlist  # noqa: F401,E501
from aura_engine_api.rest.models.timeslot import Timeslot  # noqa: F401,E501


class ClockInfo(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(
        self,
        engine_source=None,
        current_track=None,
        current_playlogs=None,
        planned_playlist=None,
        current_timeslot=None,
        upcoming_timeslots=None,
    ):  # noqa: E501
        """ClockInfo - a model defined in Swagger

        :param engine_source: The engine_source of this ClockInfo.  # noqa: E501
        :type engine_source: int
        :param current_track: The current_track of this ClockInfo.  # noqa: E501
        :type current_track: PlayLog
        :param current_playlogs: The current_playlogs of this ClockInfo.  # noqa: E501
        :type current_playlogs: List[PlayLog]
        :param planned_playlist: The planned_playlist of this ClockInfo.  # noqa: E501
        :type planned_playlist: Playlist
        :param current_timeslot: The current_timeslot of this ClockInfo.  # noqa: E501
        :type current_timeslot: Timeslot
        :param upcoming_timeslots: The upcoming_timeslots of this ClockInfo.  # noqa: E501
        :type upcoming_timeslots: List[Timeslot]
        """
        self.swagger_types = {
            "engine_source": int,
            "current_track": PlayLog,
            "current_playlogs": List[PlayLog],
            "planned_playlist": Playlist,
            "current_timeslot": Timeslot,
            "upcoming_timeslots": List[Timeslot],
        }

        self.attribute_map = {
            "engine_source": "engineSource",
            "current_track": "currentTrack",
            "current_playlogs": "currentPlaylogs",
            "planned_playlist": "plannedPlaylist",
            "current_timeslot": "currentTimeslot",
            "upcoming_timeslots": "upcomingTimeslots",
        }
        self._engine_source = engine_source
        self._current_track = current_track
        self._current_playlogs = current_playlogs
        self._planned_playlist = planned_playlist
        self._current_timeslot = current_timeslot
        self._upcoming_timeslots = upcoming_timeslots

    @classmethod
    def from_dict(cls, dikt):
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The ClockInfo of this ClockInfo.  # noqa: E501
        :rtype: ClockInfo
        """
        return util.deserialize_model(dikt, cls)

    @property
    def engine_source(self):
        """Gets the engine_source of this ClockInfo.


        :return: The engine_source of this ClockInfo.
        :rtype: int
        """
        return self._engine_source

    @engine_source.setter
    def engine_source(self, engine_source):
        """Sets the engine_source of this ClockInfo.


        :param engine_source: The engine_source of this ClockInfo.
        :type engine_source: int
        """

        self._engine_source = engine_source

    @property
    def current_track(self):
        """Gets the current_track of this ClockInfo.


        :return: The current_track of this ClockInfo.
        :rtype: PlayLog
        """
        return self._current_track

    @current_track.setter
    def current_track(self, current_track):
        """Sets the current_track of this ClockInfo.


        :param current_track: The current_track of this ClockInfo.
        :type current_track: PlayLog
        """

        self._current_track = current_track

    @property
    def current_playlogs(self):
        """Gets the current_playlogs of this ClockInfo.


        :return: The current_playlogs of this ClockInfo.
        :rtype: List[PlayLog]
        """
        return self._current_playlogs

    @current_playlogs.setter
    def current_playlogs(self, current_playlogs):
        """Sets the current_playlogs of this ClockInfo.


        :param current_playlogs: The current_playlogs of this ClockInfo.
        :type current_playlogs: List[PlayLog]
        """

        self._current_playlogs = current_playlogs

    @property
    def planned_playlist(self):
        """Gets the planned_playlist of this ClockInfo.


        :return: The planned_playlist of this ClockInfo.
        :rtype: Playlist
        """
        return self._planned_playlist

    @planned_playlist.setter
    def planned_playlist(self, planned_playlist):
        """Sets the planned_playlist of this ClockInfo.


        :param planned_playlist: The planned_playlist of this ClockInfo.
        :type planned_playlist: Playlist
        """

        self._planned_playlist = planned_playlist

    @property
    def current_timeslot(self):
        """Gets the current_timeslot of this ClockInfo.


        :return: The current_timeslot of this ClockInfo.
        :rtype: Timeslot
        """
        return self._current_timeslot

    @current_timeslot.setter
    def current_timeslot(self, current_timeslot):
        """Sets the current_timeslot of this ClockInfo.


        :param current_timeslot: The current_timeslot of this ClockInfo.
        :type current_timeslot: Timeslot
        """

        self._current_timeslot = current_timeslot

    @property
    def upcoming_timeslots(self):
        """Gets the upcoming_timeslots of this ClockInfo.


        :return: The upcoming_timeslots of this ClockInfo.
        :rtype: List[Timeslot]
        """
        return self._upcoming_timeslots

    @upcoming_timeslots.setter
    def upcoming_timeslots(self, upcoming_timeslots):
        """Sets the upcoming_timeslots of this ClockInfo.


        :param upcoming_timeslots: The upcoming_timeslots of this ClockInfo.
        :type upcoming_timeslots: List[Timeslot]
        """

        self._upcoming_timeslots = upcoming_timeslots
