# coding: utf-8

from __future__ import absolute_import

from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from aura_engine_api.rest import util
from aura_engine_api.rest.models.base_model_ import Model


class PlayLog(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(
        self,
        track_start=None,
        track_artist=None,
        track_album=None,
        track_title=None,
        track_duration=None,
        track_type=None,
        track_num=None,
        playlist_id=None,
        timeslot_id=None,
        show_id=None,
        show_name=None,
        log_source=None,
        custom_json=None,
        is_synced=None,
    ):  # noqa: E501
        """PlayLog - a model defined in Swagger

        :param track_start: The track_start of this PlayLog.  # noqa: E501
        :type track_start: datetime
        :param track_artist: The track_artist of this PlayLog.  # noqa: E501
        :type track_artist: str
        :param track_album: The track_album of this PlayLog.  # noqa: E501
        :type track_album: str
        :param track_title: The track_title of this PlayLog.  # noqa: E501
        :type track_title: str
        :param track_duration: The track_duration of this PlayLog.  # noqa: E501
        :type track_duration: int
        :param track_type: The track_type of this PlayLog.  # noqa: E501
        :type track_type: int
        :param track_num: The track_num of this PlayLog.  # noqa: E501
        :type track_num: int
        :param playlist_id: The playlist_id of this PlayLog.  # noqa: E501
        :type playlist_id: int
        :param timeslot_id: The timeslot_id of this PlayLog.  # noqa: E501
        :type timeslot_id: int
        :param show_id: The show_id of this PlayLog.  # noqa: E501
        :type show_id: int
        :param show_name: The show_name of this PlayLog.  # noqa: E501
        :type show_name: str
        :param log_source: The log_source of this PlayLog.  # noqa: E501
        :type log_source: int
        :param custom_json: The custom_json of this PlayLog.  # noqa: E501
        :type custom_json: str
        :param is_synced: The is_synced of this PlayLog.  # noqa: E501
        :type is_synced: bool
        """
        self.swagger_types = {
            "track_start": datetime,
            "track_artist": str,
            "track_album": str,
            "track_title": str,
            "track_duration": int,
            "track_type": int,
            "track_num": int,
            "playlist_id": int,
            "timeslot_id": int,
            "show_id": int,
            "show_name": str,
            "log_source": int,
            "custom_json": str,
            "is_synced": bool,
        }

        self.attribute_map = {
            "track_start": "trackStart",
            "track_artist": "trackArtist",
            "track_album": "trackAlbum",
            "track_title": "trackTitle",
            "track_duration": "trackDuration",
            "track_type": "trackType",
            "track_num": "trackNum",
            "playlist_id": "playlistId",
            "timeslot_id": "timeslotId",
            "show_id": "showId",
            "show_name": "showName",
            "log_source": "logSource",
            "custom_json": "customJson",
            "is_synced": "isSynced",
        }
        self._track_start = track_start
        self._track_artist = track_artist
        self._track_album = track_album
        self._track_title = track_title
        self._track_duration = track_duration
        self._track_type = track_type
        self._track_num = track_num
        self._playlist_id = playlist_id
        self._timeslot_id = timeslot_id
        self._show_id = show_id
        self._show_name = show_name
        self._log_source = log_source
        self._custom_json = custom_json
        self._is_synced = is_synced

    @classmethod
    def from_dict(cls, dikt):
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The PlayLog of this PlayLog.  # noqa: E501
        :rtype: PlayLog
        """
        return util.deserialize_model(dikt, cls)

    @property
    def track_start(self):
        """Gets the track_start of this PlayLog.


        :return: The track_start of this PlayLog.
        :rtype: datetime
        """
        return self._track_start

    @track_start.setter
    def track_start(self, track_start):
        """Sets the track_start of this PlayLog.


        :param track_start: The track_start of this PlayLog.
        :type track_start: datetime
        """
        if track_start is None:
            raise ValueError("Invalid value for `track_start`, must not be `None`")  # noqa: E501

        self._track_start = track_start

    @property
    def track_artist(self):
        """Gets the track_artist of this PlayLog.


        :return: The track_artist of this PlayLog.
        :rtype: str
        """
        return self._track_artist

    @track_artist.setter
    def track_artist(self, track_artist):
        """Sets the track_artist of this PlayLog.


        :param track_artist: The track_artist of this PlayLog.
        :type track_artist: str
        """

        self._track_artist = track_artist

    @property
    def track_album(self):
        """Gets the track_album of this PlayLog.


        :return: The track_album of this PlayLog.
        :rtype: str
        """
        return self._track_album

    @track_album.setter
    def track_album(self, track_album):
        """Sets the track_album of this PlayLog.


        :param track_album: The track_album of this PlayLog.
        :type track_album: str
        """

        self._track_album = track_album

    @property
    def track_title(self):
        """Gets the track_title of this PlayLog.


        :return: The track_title of this PlayLog.
        :rtype: str
        """
        return self._track_title

    @track_title.setter
    def track_title(self, track_title):
        """Sets the track_title of this PlayLog.


        :param track_title: The track_title of this PlayLog.
        :type track_title: str
        """

        self._track_title = track_title

    @property
    def track_duration(self):
        """Gets the track_duration of this PlayLog.


        :return: The track_duration of this PlayLog.
        :rtype: int
        """
        return self._track_duration

    @track_duration.setter
    def track_duration(self, track_duration):
        """Sets the track_duration of this PlayLog.


        :param track_duration: The track_duration of this PlayLog.
        :type track_duration: int
        """

        self._track_duration = track_duration

    @property
    def track_type(self):
        """Gets the track_type of this PlayLog.

        Indicates the type: \"0\" = filesystem, \"1\" = stream, \"2\" = live or line in  # noqa: E501

        :return: The track_type of this PlayLog.
        :rtype: int
        """
        return self._track_type

    @track_type.setter
    def track_type(self, track_type):
        """Sets the track_type of this PlayLog.

        Indicates the type: \"0\" = filesystem, \"1\" = stream, \"2\" = live or line in  # noqa: E501

        :param track_type: The track_type of this PlayLog.
        :type track_type: int
        """

        self._track_type = track_type

    @property
    def track_num(self):
        """Gets the track_num of this PlayLog.


        :return: The track_num of this PlayLog.
        :rtype: int
        """
        return self._track_num

    @track_num.setter
    def track_num(self, track_num):
        """Sets the track_num of this PlayLog.


        :param track_num: The track_num of this PlayLog.
        :type track_num: int
        """

        self._track_num = track_num

    @property
    def playlist_id(self):
        """Gets the playlist_id of this PlayLog.


        :return: The playlist_id of this PlayLog.
        :rtype: int
        """
        return self._playlist_id

    @playlist_id.setter
    def playlist_id(self, playlist_id):
        """Sets the playlist_id of this PlayLog.


        :param playlist_id: The playlist_id of this PlayLog.
        :type playlist_id: int
        """

        self._playlist_id = playlist_id

    @property
    def timeslot_id(self):
        """Gets the timeslot_id of this PlayLog.


        :return: The timeslot_id of this PlayLog.
        :rtype: int
        """
        return self._timeslot_id

    @timeslot_id.setter
    def timeslot_id(self, timeslot_id):
        """Sets the timeslot_id of this PlayLog.


        :param timeslot_id: The timeslot_id of this PlayLog.
        :type timeslot_id: int
        """

        self._timeslot_id = timeslot_id

    @property
    def show_id(self):
        """Gets the show_id of this PlayLog.


        :return: The show_id of this PlayLog.
        :rtype: int
        """
        return self._show_id

    @show_id.setter
    def show_id(self, show_id):
        """Sets the show_id of this PlayLog.


        :param show_id: The show_id of this PlayLog.
        :type show_id: int
        """

        self._show_id = show_id

    @property
    def show_name(self):
        """Gets the show_name of this PlayLog.


        :return: The show_name of this PlayLog.
        :rtype: str
        """
        return self._show_name

    @show_name.setter
    def show_name(self, show_name):
        """Sets the show_name of this PlayLog.


        :param show_name: The show_name of this PlayLog.
        :type show_name: str
        """

        self._show_name = show_name

    @property
    def log_source(self):
        """Gets the log_source of this PlayLog.

        From which engine the entry has been logged from e.g. \"1\" for Engine 1 or \"2\" for Engine 2  # noqa: E501

        :return: The log_source of this PlayLog.
        :rtype: int
        """
        return self._log_source

    @log_source.setter
    def log_source(self, log_source):
        """Sets the log_source of this PlayLog.

        From which engine the entry has been logged from e.g. \"1\" for Engine 1 or \"2\" for Engine 2  # noqa: E501

        :param log_source: The log_source of this PlayLog.
        :type log_source: int
        """

        self._log_source = log_source

    @property
    def custom_json(self):
        """Gets the custom_json of this PlayLog.

        A stringified JSON Object allowing the future extension of the API with custom fields.  # noqa: E501

        :return: The custom_json of this PlayLog.
        :rtype: str
        """
        return self._custom_json

    @custom_json.setter
    def custom_json(self, custom_json):
        """Sets the custom_json of this PlayLog.

        A stringified JSON Object allowing the future extension of the API with custom fields.  # noqa: E501

        :param custom_json: The custom_json of this PlayLog.
        :type custom_json: str
        """

        self._custom_json = custom_json

    @property
    def is_synced(self):
        """Gets the is_synced of this PlayLog.

        For Engine API internal use only - On a main node such as Engine 1 or 2 this flag indicates if the playlog has been actively synced to the sync node. On the sync node in contrast this flag indicates if the playlog has been passively synced from one of the main nodes.  # noqa: E501

        :return: The is_synced of this PlayLog.
        :rtype: bool
        """
        return self._is_synced

    @is_synced.setter
    def is_synced(self, is_synced):
        """Sets the is_synced of this PlayLog.

        For Engine API internal use only - On a main node such as Engine 1 or 2 this flag indicates if the playlog has been actively synced to the sync node. On the sync node in contrast this flag indicates if the playlog has been passively synced from one of the main nodes.  # noqa: E501

        :param is_synced: The is_synced of this PlayLog.
        :type is_synced: bool
        """

        self._is_synced = is_synced
