# coding: utf-8

from __future__ import absolute_import

from datetime import date, datetime  # noqa: F401
from typing import Dict, List  # noqa: F401

from aura_engine_api.rest import util
from aura_engine_api.rest.models.base_model_ import Model


class Timeslot(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    def __init__(
        self,
        show_name=None,
        show_id=None,
        timeslot_id=None,
        timeslot_start=None,
        timeslot_end=None,
        playlist_id=None,
        playlist_type=None,
    ):  # noqa: E501
        """Timeslot - a model defined in Swagger

        :param show_name: The show_name of this Timeslot.  # noqa: E501
        :type show_name: str
        :param show_id: The show_id of this Timeslot.  # noqa: E501
        :type show_id: int
        :param timeslot_id: The timeslot_id of this Timeslot.  # noqa: E501
        :type timeslot_id: int
        :param timeslot_start: The timeslot_start of this Timeslot.  # noqa: E501
        :type timeslot_start: datetime
        :param timeslot_end: The timeslot_end of this Timeslot.  # noqa: E501
        :type timeslot_end: datetime
        :param playlist_id: The playlist_id of this Timeslot.  # noqa: E501
        :type playlist_id: int
        :param playlist_type: The playlist_type of this Timeslot.  # noqa: E501
        :type playlist_type: int
        """
        self.swagger_types = {
            "show_name": str,
            "show_id": int,
            "timeslot_id": int,
            "timeslot_start": datetime,
            "timeslot_end": datetime,
            "playlist_id": int,
            "playlist_type": int,
        }

        self.attribute_map = {
            "show_name": "showName",
            "show_id": "showId",
            "timeslot_id": "timeslotId",
            "timeslot_start": "timeslotStart",
            "timeslot_end": "timeslotEnd",
            "playlist_id": "playlistId",
            "playlist_type": "playlistType",
        }
        self._show_name = show_name
        self._show_id = show_id
        self._timeslot_id = timeslot_id
        self._timeslot_start = timeslot_start
        self._timeslot_end = timeslot_end
        self._playlist_id = playlist_id
        self._playlist_type = playlist_type

    @classmethod
    def from_dict(cls, dikt):
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The Timeslot of this Timeslot.  # noqa: E501
        :rtype: Timeslot
        """
        return util.deserialize_model(dikt, cls)

    @property
    def show_name(self):
        """Gets the show_name of this Timeslot.


        :return: The show_name of this Timeslot.
        :rtype: str
        """
        return self._show_name

    @show_name.setter
    def show_name(self, show_name):
        """Sets the show_name of this Timeslot.


        :param show_name: The show_name of this Timeslot.
        :type show_name: str
        """
        if show_name is None:
            raise ValueError("Invalid value for `show_name`, must not be `None`")  # noqa: E501

        self._show_name = show_name

    @property
    def show_id(self):
        """Gets the show_id of this Timeslot.


        :return: The show_id of this Timeslot.
        :rtype: int
        """
        return self._show_id

    @show_id.setter
    def show_id(self, show_id):
        """Sets the show_id of this Timeslot.


        :param show_id: The show_id of this Timeslot.
        :type show_id: int
        """

        self._show_id = show_id

    @property
    def timeslot_id(self):
        """Gets the timeslot_id of this Timeslot.


        :return: The timeslot_id of this Timeslot.
        :rtype: int
        """
        return self._timeslot_id

    @timeslot_id.setter
    def timeslot_id(self, timeslot_id):
        """Sets the timeslot_id of this Timeslot.


        :param timeslot_id: The timeslot_id of this Timeslot.
        :type timeslot_id: int
        """

        self._timeslot_id = timeslot_id

    @property
    def timeslot_start(self):
        """Gets the timeslot_start of this Timeslot.


        :return: The timeslot_start of this Timeslot.
        :rtype: datetime
        """
        return self._timeslot_start

    @timeslot_start.setter
    def timeslot_start(self, timeslot_start):
        """Sets the timeslot_start of this Timeslot.


        :param timeslot_start: The timeslot_start of this Timeslot.
        :type timeslot_start: datetime
        """

        self._timeslot_start = timeslot_start

    @property
    def timeslot_end(self):
        """Gets the timeslot_end of this Timeslot.


        :return: The timeslot_end of this Timeslot.
        :rtype: datetime
        """
        return self._timeslot_end

    @timeslot_end.setter
    def timeslot_end(self, timeslot_end):
        """Sets the timeslot_end of this Timeslot.


        :param timeslot_end: The timeslot_end of this Timeslot.
        :type timeslot_end: datetime
        """

        self._timeslot_end = timeslot_end

    @property
    def playlist_id(self):
        """Gets the playlist_id of this Timeslot.


        :return: The playlist_id of this Timeslot.
        :rtype: int
        """
        return self._playlist_id

    @playlist_id.setter
    def playlist_id(self, playlist_id):
        """Sets the playlist_id of this Timeslot.


        :param playlist_id: The playlist_id of this Timeslot.
        :type playlist_id: int
        """

        self._playlist_id = playlist_id

    @property
    def playlist_type(self):
        """Gets the playlist_type of this Timeslot.

        Indicates on which scheduling level the playlist was assigned to the timeslot (-1=fallback, 0=timeslot, 1=schedule, 2=show, 3=station)  # noqa: E501

        :return: The playlist_type of this Timeslot.
        :rtype: int
        """
        return self._playlist_type

    @playlist_type.setter
    def playlist_type(self, playlist_type):
        """Sets the playlist_type of this Timeslot.

        Indicates on which scheduling level the playlist was assigned to the timeslot (-1=fallback, 0=timeslot, 1=schedule, 2=show, 3=station)  # noqa: E501

        :param playlist_type: The playlist_type of this Timeslot.
        :type playlist_type: int
        """

        self._playlist_type = playlist_type
